XChaCha20Poly1305_Final< T_IsEncryption > Class Template Reference

IETF XChaCha20Poly1305 cipher final implementation. More...

`#include <chachapoly.h>`

Inheritance diagram for XChaCha20Poly1305_Final< T_IsEncryption >:

## Additional Inherited Members

Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0 , RANDOM_IV , UNPREDICTABLE_RANDOM_IV , INTERNALLY_GENERATED_IV , NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...
Public Member Functions inherited from XChaCha20Poly1305_Base
std::string | AlgorithmName () const
| Provides the name of this algorithm.
std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm.
size_t | MinKeyLength () const
| Returns smallest valid key length.
size_t | MaxKeyLength () const
| Returns largest valid key length.
size_t | DefaultKeyLength () const
| Returns default key length.
size_t | GetValidKeyLength (size_t n) const
| Returns a valid key length for the algorithm.
bool | IsValidKeyLength (size_t n) const
| Returns whether keylength is a valid key length.
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance.
IV_Requirement | IVRequirement () const
| Minimal requirement for secure IVs.
unsigned int | IVSize () const
| Returns length of the IV accepted by this object.
unsigned int | MinIVLength () const
| Provides the minimum size of an IV.
unsigned int | MaxIVLength () const
| Provides the maximum size of an IV.
unsigned int | DigestSize () const
| Provides the digest size of the hash.
lword | MaxHeaderLength () const
| Provides the maximum length of AAD that can be input.
lword | MaxMessageLength () const
| Provides the maximum length of encrypted data.
lword | MaxFooterLength () const
| Provides the maximum length of AAD.
virtual void | EncryptAndAuthenticate (byte *ciphertext, byte *mac, size_t macSize, const byte *iv, int ivLength, const byte *aad, size_t aadLength, const byte *message, size_t messageLength)
| Encrypts and calculates a MAC in one call.
virtual bool | DecryptAndVerify (byte *message, const byte *mac, size_t macSize, const byte *iv, int ivLength, const byte *aad, size_t aadLength, const byte *ciphertext, size_t ciphertextLength)
| Decrypts and verifies a MAC in one call.
Public Member Functions inherited from AuthenticatedSymmetricCipherBase
bool | IsRandomAccess () const
| Determines whether the cipher supports random access.
bool | IsSelfInverting () const
| Determines whether the cipher is self-inverting.
void | SetKey (const byte *userKey, size_t keylength, const NameValuePairs &params)
| Sets or reset the key of this object.
void | Restart ()
| Restart the hash.
void | Resynchronize (const byte *iv, int length=-1)
| Resynchronize with an IV.
void | Update (const byte *input, size_t length)
| Updates a hash with additional input.
void | ProcessData (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt an array of bytes.
void | TruncatedFinal (byte *mac, size_t macSize)
| Computes the hash of the current message.
Public Member Functions inherited from AuthenticatedSymmetricCipher
virtual bool | NeedsPrespecifiedDataLengths () const
| Determines if data lengths must be specified prior to inputting data.
void | SpecifyDataLengths (lword headerLength, lword messageLength, lword footerLength=0)
| Prescribes the data lengths.
Public Member Functions inherited from SimpleKeyingInterface
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object.
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object.
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object.
bool | IsResynchronizable () const
| Determines if the object can be resynchronized.
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs.
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs.
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs.
unsigned int | DefaultIVLength () const
| Provides the default size of an IV.
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message.
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object.
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller.
virtual void | Final (byte *digest)
| Computes the hash of the current message.
unsigned int | TagSize () const
| Provides the tag size of the hash.
virtual unsigned int | BlockSize () const
| Provides the block size of the compression function.
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash.
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message.
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message.
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message.
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message.
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message.
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message.
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms.
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object.
Public Member Functions inherited from StreamTransformation
StreamTransformation & | Ref ()
| Provides a reference to this object.
virtual unsigned int | MandatoryBlockSize () const
| Provides the mandatory block size of the cipher.
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher.
virtual unsigned int | GetOptimalBlockSizeUsed () const
| Provides the number of bytes used in the current block when processing at optimal block size.
virtual size_t | ProcessLastBlock (byte *outString, size_t outLength, const byte *inString, size_t inLength)
| Encrypt or decrypt the last block of data.
virtual unsigned int | MinLastBlockSize () const
| Provides the size of the last block.
virtual bool | IsLastBlockSpecial () const
| Determines if the last block receives special processing.
void | ProcessString (byte *inoutString, size_t length)
| Encrypt or decrypt a string of bytes.
void | ProcessString (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt a string of bytes.
byte | ProcessByte (byte input)
| Encrypt or decrypt a byte.
virtual void | Seek (lword pos)
| Seek to an absolute position.
Static Public Member Functions inherited from XChaCha20Poly1305_Base
static const char * | StaticAlgorithmName ()

## Detailed Description

template<bool T_IsEncryption>
class XChaCha20Poly1305_Final< T_IsEncryption >

IETF XChaCha20Poly1305 cipher final implementation.

Template Parameters

  T_IsEncryption | flag indicating cipher direction

XChaCha20Poly1305 is an authenticated encryption scheme that combines XChaCha20 and Poly1305-TLS. The scheme is defined in RFC 8439, section 2.8, AEAD_CHACHA20_POLY1305 construction, and uses the IETF versions of ChaCha20 and Poly1305.

See also
  RFC 8439, ChaCha20 and Poly1305 for IETF Protocols.

Since
  Crypto++ 8.1

Definition at line 281 of file chachapoly.h.

## Constructor & Destructor Documentation

## ~XChaCha20Poly1305_Final()

template<bool T_IsEncryption>

virtual XChaCha20Poly1305_Final< T_IsEncryption >::~XChaCha20Poly1305_Final | ( |  | ) |

inline virtual

Definition at line 284 of file chachapoly.h.

The documentation for this class was generated from the following file:

- chachapoly.h